package com.jiayue.test.mail;

import cn.hutool.core.io.resource.ResourceUtil;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.jiayue.test.entity.EmailParam;
import java.util.Calendar;
import java.util.List;
import java.util.Map;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

@Component
public class ApplicationRunnerImpl implements ApplicationRunner {
    private static final Logger log = LoggerFactory.getLogger(ApplicationRunnerImpl.class);

    @Value("${spring.mail.username}")
    private String from;

    @Value("${templatePath}")
    private String templatePath;

    @Value("${filePath}")
    private String filePath;

    @Autowired
    private SendEmailUtils sendEmailUtils;

    public void run(ApplicationArguments args) throws Exception {
        log.info("通过实现ApplicationRunner接口，在spring boot项目启动后执行一次读取文件并发送邮件");
         ExcelReader reader = ExcelUtil.getReader(ResourceUtil.getStream(this.filePath));
        Calendar cale = null;
        cale = Calendar.getInstance();
        int year = cale.get(1);
        int month = cale.get(2);
        List<Map<String, Object>> readAll = reader.readAll();
        int index = 0;
        for (Map<String, Object> map : readAll) {
            index++;
            if (index > 1)
                try {
                    EmailParam emailParam = new EmailParam();
                    emailParam.setC1(getVal(map.get("c1")));
                    emailParam.setC2(getVal(map.get("c2")));
                    emailParam.setC3(getVal(map.get("c3")));
                    emailParam.setC4(getVal(map.get("c4")));
                    emailParam.setC5(getVal(map.get("c5")));
                    emailParam.setC6(getVal(map.get("c6")));
                    emailParam.setC7(getVal(map.get("c7")));
                    emailParam.setC8(getVal(map.get("c8")));
                    emailParam.setC9(getVal(map.get("c9")));
                    emailParam.setC10(getVal(map.get("c10")));
                    emailParam.setC11(getVal(map.get("c11")));
                    emailParam.setC12(getVal(map.get("c12")));
                    emailParam.setC13(getVal(map.get("c13")));
                    emailParam.setC14(getVal(map.get("c14")));
                    emailParam.setC15(getVal(map.get("c15")));
                    emailParam.setC16(getVal(map.get("c16")));
                    emailParam.setC17(getVal(map.get("c17")));
                    emailParam.setC18(getVal(map.get("c18")));
                    emailParam.setC19(getVal(map.get("c19")));
                    emailParam.setC20(getVal(map.get("c20")));
                    emailParam.setC21(getVal(map.get("c21")));
                    emailParam.setC22(getVal(map.get("c22")));
                    emailParam.setC23(getVal(map.get("c23")));
                    emailParam.setC24(getVal(map.get("c24")));
                    emailParam.setC25(getVal(map.get("c25")));
                    emailParam.setC26(getVal(map.get("c26")));
                    String[] to = { map.get("c2").toString() };
                    if (to.length > 0 && !to[0].isEmpty()) {
                        this.sendEmailUtils.thymeleafEmail(this.from, to, map.get("c1").toString() + year + "年"+month +"月份工资邮件", emailParam, this.templatePath);
                        log.info(map.get("c2").toString() + ":Send Success!");
                        Thread.sleep(1000L);
                    }
                } catch (Exception e) {
                    log.error(map.get("c1").toString() + ":Send Faild!", e);
                }
        }
        log.info("All mail sent!!!");
    }

    public String getVal(Object object) {
        if (object != null)
            return object.toString();
        return "";
    }
}
