package com.jiayue.test.mail;

import com.jiayue.test.entity.EmailParam;
import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;
import org.springframework.stereotype.Component;
import org.thymeleaf.TemplateEngine;
import org.thymeleaf.context.Context;
import org.thymeleaf.context.IContext;

@Component
public class SendEmailUtils {
    @Autowired
    private JavaMailSender javaMailSender;

    @Autowired
    private TemplateEngine templateEngine;

    public void thymeleafEmail(String from, String[] to, String subject, EmailParam emailParam, String template) throws MessagingException {
        MimeMessage mimeMessage = this.javaMailSender.createMimeMessage();
        MimeMessageHelper mimeMessageHelper = new MimeMessageHelper(mimeMessage, true);
        mimeMessageHelper.setFrom(from);
        mimeMessageHelper.setTo(to);
        mimeMessageHelper.setSubject(subject);
        Context ctx = new Context();
        ctx.setVariable("emailParam", emailParam);
        String emailText = this.templateEngine.process(template, (IContext)ctx);
        mimeMessageHelper.setText(emailText, true);
        this.javaMailSender.send(mimeMessage);
    }
}
